<script setup lang="ts">
import { PlayCircle } from 'slippers-ui/icons';
import { ref } from 'vue';

interface VideoModalLoop {
  config: {
    videoSrc: string;
    videoMP4: string;
    videoWebm: string;
    thumbnailSrc?: string;
    theme?: string;
  };
}

defineProps<VideoModalLoop>();
const modalOpen = ref(false);
const openModal = () => {
  modalOpen.value = true;
};
const closeModal = () => {
  modalOpen.value = false;
};
</script>

<template>
  <div>
    <div class="video-modal-loop" :class="`video-modal-loop--${config?.theme}`" @click="openModal()">
      <SlpIcon :icon="PlayCircle" size="xl" class="video-modal-loop__play-icon" />
      <video class="video-modal-loop__video-looping" autoplay loop muted playsinline>
        <source :src="config.videoMP4" type="video/mp4" />
        <source :src="config.videoWebm" type="video/webm" />
      </video>
    </div>

    <CommonVideoModal :visible="modalOpen" @close="closeModal">
      <template #body>
        <CommonVideo :video-src="config.videoSrc" class="video" :thumbnail-src="config.thumbnailSrc"> </CommonVideo>
      </template>
    </CommonVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.video-modal-loop {
  position: relative;
  cursor: pointer;
  &__play-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 48px;
    color: $color-surface-700;
    cursor: pointer;
    z-index: 2;
    border: 2px solid $color-surface-600;
    border-radius: 9999px;
    box-sizing: content-box;
    width: 96px;
    height: 96px;
    transition: color 0.2s ease;
    path {
      fill: $color-surface-50;
      transition: color 0.2s ease;
    }

    circle {
      fill: currentColor;
      transition: color 0.2s ease;
    }
  }
  &__video-looping {
    width: 100%;
    filter: brightness(0.6);
  }
  &:hover {
    .video-modal-loop__play-icon {
      color: #1e1d43;
      path {
        color: $color-surface-50;
      }
    }
  }
  &--dark {
    background-color: $color-primary-200;
  }
}
</style>
